<?php


function wp_pp_init(){
	
	// load translations
	load_plugin_textdomain( WP_PP_TEXTDOMAIN, false , WP_PP_TEXTDOMAIN."/languages/" );
	
	// create first time plugin option base
	if( !get_option( 'wp_posts_playlist' ) ) {
	
		$wp_posts_playlist['icon'] 					= "star.png";
		$wp_posts_playlist['favorite_add'] 			= "Add as favorites";
		$wp_posts_playlist['favorite_del'] 			= "Delete from favorites";
		
		$wp_posts_playlist['show_in_posts'] 		= "show";
		$wp_posts_playlist['show_in_pages'] 		= "hidden";
		$wp_posts_playlist['show_in_loop'] 			= "hidden";

		$wp_posts_playlist['show_slider'] 			= "show";
		$wp_posts_playlist['slider_bg'] 			= "#EEEEEE";
		$wp_posts_playlist['slider_bg_box']			= "#FFFFFF";
		$wp_posts_playlist['slider_bg_box_link']	= "#FFFFFF";
		$wp_posts_playlist['featured_image'] 		= "show";
		$wp_posts_playlist['playlist_label'] 		= "Posts Playlist";
		$wp_posts_playlist['playlist_label_color'] 	= "#0000FF";
		
		add_option('wp_posts_playlist', $wp_posts_playlist);
		
	}
	
	// add custom styles and scripts
	if( !empty($_GET['page']) && $_GET['page'] == WP_PP_TEXTDOMAIN ){
		
		add_action('admin_print_styles', 'wp_pp_add_style');
		add_action('admin_print_scripts', 'wp_pp_add_js_script');
	}
	
	global $table_prefix, $wpdb;
	
	$wp_pp_posts_playlist_table = $table_prefix . "posts_playlist";
	 
	#Check to see if the table exists already, if not, then create it
	if($wpdb->get_var("show tables like '$wp_pp_posts_playlist_table'") != $wp_pp_posts_playlist_table) {
			
		$_sql = "CREATE TABLE IF NOT EXISTS `".$wp_pp_posts_playlist_table."` (
		  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
		  `user_login` varchar(60) NOT NULL DEFAULT '',
		  `post_id` bigint(20) NOT NULL,
		  PRIMARY KEY (`ID`)
		) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;";
		
		
		#We need to include this file so we have access to the dbDelta function below (which is used to create the table)
		require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
		dbDelta($_sql);
	}
	 

}

function wp_pp_add_js_script() {
	wp_enqueue_script( WP_PP_TEXTDOMAIN, WP_PP_ROOT."/js/logic.js", array( 'jquery' ) );
}


function wp_pp_add_style() { 
	wp_register_style(WP_PP_TEXTDOMAIN, WP_PP_ROOT.'/css/style-admin.css');
	wp_enqueue_style(WP_PP_TEXTDOMAIN); 
}

function wp_pp_install()
{
	/* This function show a config page in WP control panel */
	add_options_page('Posts Playlist','Posts Playlist','manage_options','wp-posts-playlist','wp_pp_config');
}


function wp_pp_config(){
	// get option from wordpress
	$wp_posts_playlist = get_option('wp_posts_playlist');
	include(dirname(__FILE__).'/../templates/option-page.php');
}


function wp_pp_update_settings(){
	global $wpdb, $current_user;
 
	// if button is pressed...
	if(isset($_POST['update']))
	{
		
		$wp_posts_playlist['icon'] 					= htmlspecialchars($_POST['icon']);
		$wp_posts_playlist['favorite_add'] 			= htmlspecialchars($_POST['favorite_add']);
		$wp_posts_playlist['favorite_del'] 			= htmlspecialchars($_POST['favorite_del']);
	
		$wp_posts_playlist['show_in_posts'] 		= htmlspecialchars($_POST['show_in_posts']);
		$wp_posts_playlist['show_in_pages'] 		= htmlspecialchars($_POST['show_in_pages']);
		$wp_posts_playlist['show_in_loop'] 			= htmlspecialchars($_POST['show_in_loop']);
		
		$wp_posts_playlist['show_slider'] 			= htmlspecialchars($_POST['show_slider']);
		$wp_posts_playlist['slider_bg'] 			= htmlspecialchars($_POST['slider_bg']);
		$wp_posts_playlist['slider_bg_box'] 		= htmlspecialchars($_POST['slider_bg_box']);
		$wp_posts_playlist['slider_bg_box_link'] 	= htmlspecialchars($_POST['slider_bg_box_link']);
		$wp_posts_playlist['featured_image']		= htmlspecialchars($_POST['featured_image']);
		$wp_posts_playlist['playlist_label']		= htmlspecialchars($_POST['playlist_label']);
		$wp_posts_playlist['playlist_label_color']	= htmlspecialchars($_POST['playlist_label_color']);
		
		
		// update option in wordpress
		update_option('wp_posts_playlist', $wp_posts_playlist);
		
		
	}
 
}

function remove_favorite($post_id) {
	
	global $wpdb, $table_prefix, $current_user;
	$wp_pp_posts_playlist_table = $table_prefix . "posts_playlist";
	
	$_sql = "DELETE FROM ".$wp_pp_posts_playlist_table."  WHERE user_login = '".$current_user->user_login."' AND post_id = ".$post_id." ";
	$wpdb->query($_sql);
	
}

// ------------------------------------------------------------------------------
// ------------------------------------------------------------------------------

function shortcode_posts_playlist_list($atts){
	
	extract( shortcode_atts( array(
			'class' => 'pp_favorite_list'
			), $atts ) );
	
	if ( is_user_logged_in() ){

		global $wpdb,$table_prefix, $current_user;
		
		$_out   = "<div class='".$class."'><ul>";
		$data	= array();
		$_sql  	= "SELECT p.post_title,p.id as post_id
				   FROM ".$table_prefix."posts_playlist pp , ".$wpdb->posts." p
			       WHERE pp.post_id = p.ID
				   AND user_login ='".$current_user->user_login."'";

		$wpdb->query($_sql);
		
		foreach($wpdb->last_result as $k => $v){
			$_out .= "
			<li>
				<a title ='".$v->post_title."' href='?p=".$v->post_id."'>".$v->post_title."</a>
			</li>";
		};
		
		$_out .= "</ul></div>";
		
		return $_out;
	}

}



function shortcode_posts_playlist($atts){
	extract( shortcode_atts( array(
			'class' => 'pp_favorite_link'
		), $atts ) );
		
	if ( is_user_logged_in() ){
	
		global $wpdb, $post;
		
		$wp_posts_playlist = get_option('wp_posts_playlist');
		$_link  = "";
		$_link .= "<div class='".$class."'><img src='".WP_PP_ROOT.'/images/'.$wp_posts_playlist['icon']."' />";
		
		$Posts_Playlist = new Posts_Playlist($post->ID);
		
		if($Posts_Playlist->Favorite_Added()==false)
		{
			$_link .= "<a href='?action=add&post_id=".$post->ID."' > ".$wp_posts_playlist['favorite_add']." </a></div>";
		}
		else
		{
			$_link .= "<a href='?action=del&post_id=".$post->ID."' > ".$wp_posts_playlist['favorite_del']." </a></div>";
		}
		
		if(is_single() && $wp_posts_playlist['show_in_posts']=='show')
			return $_link;
		
		if(is_page() && $wp_posts_playlist['show_in_pages']=='show')
			return $_link;
		
		if(is_home() && $wp_posts_playlist['show_in_loop']=='show' )
			return $_link;
			
	}
	
	return '';	
	
}



function wp_pp_link_favorite($content = '')
{
	return do_shortcode("[posts_playlist]").$content;
}

 
function wp_pp_favorite_posts() {
    
	$Posts_Playlist = new Posts_Playlist($_REQUEST['post_id']);
	
	if ($_REQUEST['action']=="add")	{
		$Posts_Playlist->Add();
	}
	
	if ($_REQUEST['action']=="del")	{
		$Posts_Playlist->Delete();
	}
	
}

function wp_pp_load_scripts() {
	wp_enqueue_script('jquery');
}
add_action('wp_enqueue_scripts', 'wp_pp_load_scripts');



 

function load_header_old() {
	
	
	if ( is_user_logged_in() ) {
			
		global $wpdb,$table_prefix,$current_user;
		get_currentuserinfo();
	
		// load translations
		load_plugin_textdomain( WP_PP_TEXTDOMAIN, false, dirname( plugin_basename( __FILE__ ) ) . '../../languages/' );
	
		$wp_posts_playlist = get_option('wp_posts_playlist');
	?>
		<style>
		#posts_playlist_slider {
			position:relative;
			background:<?php echo $wp_posts_playlist['slider_bg']; ?>;
			padding:20px;
			height:200px;
			overflow:hidden;
		}
		#posts_playlist_slider .posts_playlist_weapper {
			height:200px;
			position:relative;
			width: 980px;
			overflow:hidden;
			margin: 0 auto;
			}
		#posts_playlist_slider .posts_playlist_weapper .box {
			background:yellow;
			width:200px;
			height:200px;
			float:left;
			margin:0 10px;
			}
		#posts_playlist_slider .posts_playlist_weapper .box:first-child {
			margin-left:0;
		}
		</style>
		
		<div id="posts_playlist_slider">
			<div class="posts_playlist_weapper">
			<?php
				 
			$data   =   array();
			$_sql = "
				SELECT post_id,user_login,post_title
				FROM ".$table_prefix."posts_playlist pp,".$wpdb->posts." p
				WHERE 1=1
				AND user_login ='".$current_user->user_login."'
				AND p.ID=pp.post_id";

			$wpdb->query($_sql);
			
			foreach($wpdb->last_result as $k => $v){
				echo "
				<div class='box'>
					<a class ='posts-link-title' href='?p=".$v->post_id."'>".$v->post_title."</a>
					<a class='posts-link-action' href='?action=del&post_id=".$v->post_id."'> Rimuovi </a>
				</div>";
				
				
			};
			 
			
			
			?>
			</div>
			<a href="javascript:void(0);" class="prev"><?php echo __('Prev', WP_PP_TEXTDOMAIN); ?></a> | <a href="javascript:void(0);" class="next"><?php echo __('Next', WP_PP_TEXTDOMAIN); ?></a>
		</div>
		
		<script>
		jQuery(function($){
			$("#posts_playlist_slider .next").click(function(){
				$("#posts_playlist_slider .posts_playlist_weapper .box:first").appendTo("#posts_playlist_slider .posts_playlist_weapper");
			});	
			$("#posts_playlist_slider .prev").click(function(){
				$("#posts_playlist_slider .posts_playlist_weapper .box:last").prependTo("#posts_playlist_slider .posts_playlist_weapper");
			});	
		});
		</script> 
	
<?php
	}
}



function load_header() {
	if ( is_user_logged_in() ) {
		
		global $wpdb,$table_prefix,$current_user;
		// get option from wordpress
		$wp_posts_playlist = get_option('wp_posts_playlist');
		include(dirname(__FILE__).'/../templates/slider-page.php');

	}
		
}







?>