<?php
/*
Plugin Name: Wp Posts Playlist
Plugin URI: http://pasqualeambrosio.com/wordpress-plugin/wp-posts-playlist/
Description: Allows users logged to create a playlist of their favorite posts
Version: 1.3.3
Author: Pasquale Ambrosio
Author URI: http://www.pasqualeambrosio.com
License: GPLv2
*/

/* Release History :
   1.0:     initial release
   1.1:     fix bug query
   1.2:     add delete favorite when delete post
   1.2.1:	use table_prefix in some case
   1.2.2:	use internal jquery wp
   1.2.3:	fix bug
   1.3.0:	fix slider jquery conflict
   1.3.1:	change style of title preview
   1.3.2:	add widget feature
   1.3.3:   fix bug carousel
 */

define('WP_PP_ROOT', plugins_url().'/wp-posts-playlist');
define('WP_PP_TEXTDOMAIN', 'wp-posts-playlist');
	
require_once(dirname(__FILE__).'/includes/core.php');
require_once(dirname(__FILE__).'/includes/class_post_playlist.php');
require_once(dirname(__FILE__).'/includes/widget.post_playlist.php');

	
if( is_admin() )
{	
	add_action('trash_post', 'remove_favorite');
	add_action('plugins_loaded', 'wp_pp_init');
	add_action('admin_menu', 'wp_pp_install');
	add_action('init', 'wp_pp_update_settings');
}

add_action('template_redirect', 'wp_pp_favorite_posts');
add_filter('the_content', 'wp_pp_link_favorite');
add_shortcode ('posts_playlist', 'shortcode_posts_playlist');
add_shortcode ('posts_playlist_list', 'shortcode_posts_playlist_list');

add_action('wp_head', 'load_header');

?>